<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;klw0pjcx3gcsqz561gi1wwv8hj1lg84w-vendored-sources&#x2F;postcard-0.7.3&#x2F;src&#x2F;lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../postcard/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
</pre><pre class="rust"><code><span class="doccomment">//! # Postcard</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Postcard is a `#![no_std]` focused serializer and deserializer for Serde.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Postcard aims to be convenient for developers in constrained environments, while</span>
<span class="doccomment">//! allowing for flexibility to customize behavior as needed.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Design Goals</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! 1. Design primarily for `#![no_std]` usage, in embedded or other constrained contexts</span>
<span class="doccomment">//! 2. Support a maximal set of `serde` features, so `postcard` can be used as a drop in replacement</span>
<span class="doccomment">//! 3. Avoid special differences in code between communication code written for a microcontroller or a desktop/server PC</span>
<span class="doccomment">//! 4. Be resource efficient - memory usage, code size, developer time, and CPU time; in that order</span>
<span class="doccomment">//! 5. Allow library users to customize the serialization and deserialization  behavior to fit their bespoke needs</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Variable Length Data</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Variable length data (such as slices) are prefixed by their length.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Length is encoded as a [Varint]. This is done for two reasons: to minimize wasted bytes</span>
<span class="doccomment">//! on the wire when sending slices with items less than 127 items (typical for embedded),</span>
<span class="doccomment">//! and to reduce compatibility issues between 32-bit and 64-bit targets due to differing sizes</span>
<span class="doccomment">//! of `usize`.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Similarly, `enum` descriminants are encoded as varints, meaning that any enum with less than</span>
<span class="doccomment">//! 127 variants will encode its discriminant as a single byte (rather than a `u32`).</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Varints in `postcard` have a maximum value of the usize for that platform. In practice, this</span>
<span class="doccomment">//! means that 64-bit targets should not send messages with slices containing `(1 &lt;&lt; 32) - 1` items</span>
<span class="doccomment">//! to 32-bit targets, which is uncommon in practice. Enum discriminants already have a fixed</span>
<span class="doccomment">//! maximum value of `(1 &lt;&lt; 32) - 1` as currently defined in Rust. Varints larger than the current platform&#39;s</span>
<span class="doccomment">//! `usize` will cause the deserialization process to return an `Err`.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! [Varint]: https://developers.google.com/protocol-buffers/docs/encoding</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Example - Serialization/Deserialization</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Postcard can serialize and deserialize messages similar to other `serde` formats.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Using the default `heapless` feature to serialize to a `heapless::Vec&lt;u8&gt;`:</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ```rust</span>
<span class="doccomment">//! # #[cfg(feature = &quot;heapless&quot;)] {</span>
<span class="doccomment">//! use core::ops::Deref;</span>
<span class="doccomment">//! use serde::{Serialize, Deserialize};</span>
<span class="doccomment">//! use postcard::{from_bytes, to_vec};</span>
<span class="doccomment">//! use heapless::Vec;</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! #[derive(Serialize, Deserialize, Debug, Eq, PartialEq)]</span>
<span class="doccomment">//! struct RefStruct&lt;&#39;a&gt; {</span>
<span class="doccomment">//!     bytes: &amp;&#39;a [u8],</span>
<span class="doccomment">//!     str_s: &amp;&#39;a str,</span>
<span class="doccomment">//! }</span>
<span class="doccomment">//! let message = &quot;hElLo&quot;;</span>
<span class="doccomment">//! let bytes = [0x01, 0x10, 0x02, 0x20];</span>
<span class="doccomment">//! let output: Vec&lt;u8, 11&gt; = to_vec(&amp;RefStruct {</span>
<span class="doccomment">//!     bytes: &amp;bytes,</span>
<span class="doccomment">//!     str_s: message,</span>
<span class="doccomment">//! }).unwrap();</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! assert_eq!(</span>
<span class="doccomment">//!     &amp;[0x04, 0x01, 0x10, 0x02, 0x20, 0x05, b&#39;h&#39;, b&#39;E&#39;, b&#39;l&#39;, b&#39;L&#39;, b&#39;o&#39;,],</span>
<span class="doccomment">//!     output.deref()</span>
<span class="doccomment">//! );</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! let out: RefStruct = from_bytes(output.deref()).unwrap();</span>
<span class="doccomment">//! assert_eq!(</span>
<span class="doccomment">//!     out,</span>
<span class="doccomment">//!     RefStruct {</span>
<span class="doccomment">//!         bytes: &amp;bytes,</span>
<span class="doccomment">//!         str_s: message,</span>
<span class="doccomment">//!     }</span>
<span class="doccomment">//! );</span>
<span class="doccomment">//! # }</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Or the optional `alloc` feature to serialize to an `alloc::vec::Vec&lt;u8&gt;`:</span>
<span class="doccomment">//! ```rust</span>
<span class="doccomment">//! # #[cfg(feature = &quot;alloc&quot;)] {</span>
<span class="doccomment">//! use core::ops::Deref;</span>
<span class="doccomment">//! use serde::{Serialize, Deserialize};</span>
<span class="doccomment">//! use postcard::{from_bytes, to_allocvec};</span>
<span class="doccomment">//! extern crate alloc;</span>
<span class="doccomment">//! use alloc::vec::Vec;</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! #[derive(Serialize, Deserialize, Debug, Eq, PartialEq)]</span>
<span class="doccomment">//! struct RefStruct&lt;&#39;a&gt; {</span>
<span class="doccomment">//!     bytes: &amp;&#39;a [u8],</span>
<span class="doccomment">//!     str_s: &amp;&#39;a str,</span>
<span class="doccomment">//! }</span>
<span class="doccomment">//! let message = &quot;hElLo&quot;;</span>
<span class="doccomment">//! let bytes = [0x01, 0x10, 0x02, 0x20];</span>
<span class="doccomment">//! let output: Vec&lt;u8&gt; = to_allocvec(&amp;RefStruct {</span>
<span class="doccomment">//!     bytes: &amp;bytes,</span>
<span class="doccomment">//!     str_s: message,</span>
<span class="doccomment">//! }).unwrap();</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! assert_eq!(</span>
<span class="doccomment">//!     &amp;[0x04, 0x01, 0x10, 0x02, 0x20, 0x05, b&#39;h&#39;, b&#39;E&#39;, b&#39;l&#39;, b&#39;L&#39;, b&#39;o&#39;,],</span>
<span class="doccomment">//!     output.deref()</span>
<span class="doccomment">//! );</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! let out: RefStruct = from_bytes(output.deref()).unwrap();</span>
<span class="doccomment">//! assert_eq!(</span>
<span class="doccomment">//!     out,</span>
<span class="doccomment">//!     RefStruct {</span>
<span class="doccomment">//!         bytes: &amp;bytes,</span>
<span class="doccomment">//!         str_s: message,</span>
<span class="doccomment">//!     }</span>
<span class="doccomment">//! );</span>
<span class="doccomment">//! # }</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Example - Flavors</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! `postcard` supports a system called `Flavors`, which are used to modify the way</span>
<span class="doccomment">//! postcard serializes or processes serialized data. These flavors act as &quot;plugins&quot; or &quot;middlewares&quot;</span>
<span class="doccomment">//! during the serialization process, and can be combined to obtain complex protocol formats.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Here, we serialize the given data, while simultaneously encoding it using COBS (a &quot;modification flavor&quot;),</span>
<span class="doccomment">//! and placing the output in a byte slice (a &quot;storage flavor&quot;).</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Users of `postcard` can define their own Flavors that can be combined with existing Flavors.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ```rust</span>
<span class="doccomment">//! use postcard::{</span>
<span class="doccomment">//!     serialize_with_flavor,</span>
<span class="doccomment">//!     flavors::{Cobs, Slice},</span>
<span class="doccomment">//! };</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! let mut buf = [0u8; 32];</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! let data: &amp;[u8] = &amp;[0x01, 0x00, 0x20, 0x30];</span>
<span class="doccomment">//! let buffer = &amp;mut [0u8; 32];</span>
<span class="doccomment">//! let res = serialize_with_flavor::&lt;[u8], Cobs&lt;Slice&gt;, &amp;mut [u8]&gt;(</span>
<span class="doccomment">//!     data,</span>
<span class="doccomment">//!     Cobs::try_new(Slice::new(buffer)).unwrap(),</span>
<span class="doccomment">//! ).unwrap();</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! assert_eq!(res, &amp;[0x03, 0x04, 0x01, 0x03, 0x20, 0x30, 0x00]);</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Setup - `Cargo.toml`</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Don&#39;t forget to add [the `no-std` subset](https://serde.rs/no-std.html) of `serde` along with `postcard` to the `[dependencies]` section of your `Cargo.toml`!</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ``` toml</span>
<span class="doccomment">//! # Cargo.toml</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! [dependencies]</span>
<span class="doccomment">//! postcard = &quot;0.7.2&quot;</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # By default, `serde` has the `std` feature enabled, which makes it unsuitable for embedded targets</span>
<span class="doccomment">//! # disabling default-features fixes this</span>
<span class="doccomment">//! serde = { version = &quot;1.0.*&quot;, default-features = false }</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## License</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Licensed under either of</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! - Apache License, Version 2.0 ([LICENSE-APACHE](LICENSE-APACHE) or</span>
<span class="doccomment">//!   http://www.apache.org/licenses/LICENSE-2.0)</span>
<span class="doccomment">//! - MIT license ([LICENSE-MIT](LICENSE-MIT) or http://opensource.org/licenses/MIT)</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! at your option.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ### Contribution</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Unless you explicitly state otherwise, any contribution intentionally submitted</span>
<span class="doccomment">//! for inclusion in the work by you, as defined in the Apache-2.0 license, shall be</span>
<span class="doccomment">//! dual licensed as above, without any additional terms or conditions.</span>

<span class="attribute">#![<span class="ident">cfg_attr</span>(<span class="ident">not</span>(<span class="ident">any</span>(<span class="ident">test</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;use-std&quot;</span>)), <span class="ident">no_std</span>)]</span>
<span class="attribute">#![<span class="ident">warn</span>(<span class="ident">missing_docs</span>)]</span>

<span class="kw">mod</span> <span class="ident">accumulator</span>;
<span class="kw">mod</span> <span class="ident">de</span>;
<span class="kw">mod</span> <span class="ident">error</span>;
<span class="kw">mod</span> <span class="ident">ser</span>;
<span class="kw">mod</span> <span class="ident">varint</span>;

<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">accumulator</span>::{<span class="ident">CobsAccumulator</span>, <span class="ident">FeedResult</span>};
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">de::deserializer::Deserializer</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">de</span>::{<span class="ident">from_bytes</span>, <span class="ident">from_bytes_cobs</span>, <span class="ident">take_from_bytes</span>, <span class="ident">take_from_bytes_cobs</span>};
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">error</span>::{<span class="ident">Error</span>, <span class="prelude-ty">Result</span>};
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">ser</span>::{<span class="ident">flavors</span>, <span class="ident">serialize_with_flavor</span>, <span class="ident">serializer::Serializer</span>, <span class="ident">to_slice</span>, <span class="ident">to_slice_cobs</span>};

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;heapless&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">ser</span>::{<span class="ident">to_vec</span>, <span class="ident">to_vec_cobs</span>};

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;use-std&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">ser</span>::{<span class="ident">to_stdvec</span>, <span class="ident">to_stdvec_cobs</span>};

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">ser</span>::{<span class="ident">to_allocvec</span>, <span class="ident">to_allocvec_cobs</span>};
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="postcard" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>